#ifndef FACTORY_H
#define FACTORY_H

#include <QWidget>
#include <QPushButton>
#include <QTreeWidget>

class Factory
{
public:
    Factory () { }
    virtual QWidget * createInstance () = 0;
};

class ButtonFactory : public Factory
{
public:
    QWidget * createInstance () { return new QPushButton (); }
};

class TreeFactory : public Factory
{
public:
    QWidget * createInstance ()
    {
       QTreeWidget * t = new QTreeWidget ();
       QTreeWidgetItem * b = new QTreeWidgetItem();
       b->setText (0, "branch");
       t->addTopLevelItem (b);
       QTreeWidgetItem * u = new QTreeWidgetItem();
       u->setText (0, "item");
       b->addChild (u);
       return t;
    }
};

#endif // FACTORY_H
