#include "mainwindow.h"
#include "ui_mainwindow.h"

#include "factory.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    layout = new QVBoxLayout ();
    ui->box->setLayout (layout);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_actionRun_triggered()
{
    QList <Factory *> list;
    list.append (new ButtonFactory);
    list.append (new TreeFactory);
    list.append (new ButtonFactory);

    foreach (Factory * f , list)
    {
        QWidget * w = f->createInstance();
        // w->setParent (ui->box);
        layout->addWidget (w);
        // w->show ();
    }
}
